//------------------------------------------------------------------
//                                                 SSA of price.mq4 
//                                                           mladen 
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  clrLimeGreen
#property indicator_width1  2

//
//
//    max arraySize - 5000
//    max lag - 200 (but will be slow for big lags)
//    max numberOfComputations - 20 (it just makes it "fit" more precise to source array)
//
//

#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

//
//
//
//
//

enum _enPrices
{
   pr_close,   // Close
   pr_open,    // Open
   pr_high,    // High
   pr_low,     // Low
   pr_median,  // Median
   pr_typical, // Typical
   pr_weighted // Weighted
};

extern int       Lag                  =   25;       // Lag
extern int       NumberOfComputations =    2;       // Number of computattion 
extern int       NumberOfBars         = 2000;       // Maximum number of bars to calculate
extern _enPrices Price                = PRICE_OPEN; // Price to use

double SSA[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,SSA);
      NumberOfBars = MathMin(NumberOfBars,5000);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double sourceValues[];
double calcValues[];
int start()
{
   int n = MathMin(NumberOfBars,Bars);
      if (ArraySize(sourceValues) != n) 
      {
         ArrayResize(sourceValues,n); 
         ArrayResize(calcValues,n); 
      }
      int counted_bars=IndicatorCounted();
         if(counted_bars < 0) return(-1);
         if(counted_bars > 0) counted_bars--;
              int limit = MathMin(Bars-counted_bars,n-1);
                   SetIndexDrawBegin(0,Bars-n+1);
                   static datetime barTime=0;
                   if (barTime!=Time[0])
                   {
                      barTime=Time[0];
                      limit=n-1;
                   }                        

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--) sourceValues[i]=iMA(NULL,0,1,0,MODE_SMA,Price,i);
                               fastSingular(sourceValues,n,Lag,NumberOfComputations,calcValues); ArrayCopy(SSA,calcValues);
   return(0);
}